Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbtrj.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbtrj.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbtrj.F90	(revision 3359)
@@ -26,19 +26,19 @@
    PRIVATE
 
-   INTEGER, PRIVATE   ::   kount_traj
-   INTEGER, PRIVATE   ::   n_dim, k_dim
-   INTEGER, PRIVATE   ::   trajid
-   INTEGER, PRIVATE   ::   numberid, stepid, scaling_id
-   INTEGER, PRIVATE   ::   lonid, latid, xid, yid, uvelid, vvelid, massid
-   INTEGER, PRIVATE   ::   uoid, void, uaid, vaid, uiid, viid
-   INTEGER, PRIVATE   ::   sshxid, sshyid, sstid, cntid, thkid
-   INTEGER, PRIVATE   ::   thicknessid, widthid, lengthid
-   INTEGER, PRIVATE   ::   yearid, dayid
-   INTEGER, PRIVATE   ::   mass_of_bits_id, heat_density_id
-
-   PUBLIC   traj_init           ! routine called in xxx.F90 module
-   PUBLIC   traj_write          ! routine called in xxx.F90 module
-   PUBLIC   traj_sync           ! routine called in xxx.F90 module
-   PUBLIC   traj_end            ! routine called in xxx.F90 module
+   INTEGER, PRIVATE   ::   num_traj
+   INTEGER, PRIVATE   ::   n_dim, m_dim
+   INTEGER, PRIVATE   ::   ntrajid
+   INTEGER, PRIVATE   ::   numberid, nstepid, nscaling_id
+   INTEGER, PRIVATE   ::   nlonid, nlatid, nxid, nyid, nuvelid, nvvelid, nmassid
+   INTEGER, PRIVATE   ::   nuoid, nvoid, nuaid, nvaid, nuiid, nviid
+   INTEGER, PRIVATE   ::   nsshxid, nsshyid, nsstid, ncntid, nthkid
+   INTEGER, PRIVATE   ::   nthicknessid, nwidthid, nlengthid
+   INTEGER, PRIVATE   ::   nyearid, ndayid
+   INTEGER, PRIVATE   ::   nmass_of_bits_id, nheat_density_id
+
+   PUBLIC   traj_init           ! routine called in icbini.F90 module
+   PUBLIC   traj_write          ! routine called in icbrun.F90 module
+   PUBLIC   traj_sync           ! routine called in icbrun.F90 module
+   PUBLIC   traj_end            ! routine called in icbrun.F90 module
 
 CONTAINS
@@ -46,120 +46,120 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE traj_init( nitend )
+   SUBROUTINE traj_init( ktend )
 
       ! local variables
-      INTEGER, INTENT( in )                 :: nitend
-      ! Local variables
-      INTEGER                               :: iret, k
-      CHARACTER(len=80)                     :: filename
+      INTEGER, INTENT( in )                 :: ktend
+      ! Local variables
+      INTEGER                               :: iret
+      CHARACTER(len=80)                     :: cl_filename
       TYPE(iceberg), POINTER                :: this
       TYPE(point)  , POINTER                :: pt
 
       IF( lk_mpp ) THEN
-         WRITE(filename,'("trajectory_icebergs_",I6.6,"_",I4.4,".nc")') nitend, narea-1
+         WRITE(cl_filename,'("trajectory_icebergs_",I6.6,"_",I4.4,".nc")') ktend, narea-1
       ELSE
-         WRITE(filename,'("trajectory_icebergs_",I6.6,".nc")') nitend
+         WRITE(cl_filename,'("trajectory_icebergs_",I6.6,".nc")') ktend
       ENDIF
-      IF ( lwp .AND. nn_verbose_level >= 0) WRITE(numout,'(2a)') 'icebergs, traj_init: creating ',TRIM(filename)
-
-      iret = NF90_CREATE(TRIM(filename), NF90_CLOBBER, trajid)
+      IF ( lwp .AND. nn_verbose_level >= 0) WRITE(numout,'(2a)') 'icebergs, traj_init: creating ',TRIM(cl_filename)
+
+      iret = NF90_CREATE(TRIM(cl_filename), NF90_CLOBBER, ntrajid)
       IF (iret .NE. NF90_NOERR) CALL ctl_stop('icebergs, traj_init: nf_create failed')
 
       ! Dimensions
-      iret = NF90_DEF_DIM(trajid, 'n', NF90_UNLIMITED, n_dim)
+      iret = NF90_DEF_DIM(ntrajid, 'n', NF90_UNLIMITED, n_dim)
       IF (iret .NE. NF90_NOERR) CALL ctl_stop('icebergs, traj_init: nf_def_dim n failed')
-      iret = NF90_DEF_DIM(trajid, 'k', nkounts, k_dim)
+      iret = NF90_DEF_DIM(ntrajid, 'k', nkounts, m_dim)
       IF (iret .NE. NF90_NOERR) CALL ctl_stop('icebergs, traj_init: nf_def_dim k failed')
 
       ! Variables
-      iret = NF90_DEF_VAR(trajid, 'iceberg_number', NF90_INT, (/k_dim,n_dim/), numberid)
-      iret = NF90_DEF_VAR(trajid, 'timestep', NF90_INT, n_dim, stepid)
-      iret = NF90_DEF_VAR(trajid, 'mass_scaling', NF90_DOUBLE, n_dim, scaling_id)
-      iret = NF90_DEF_VAR(trajid, 'lon', NF90_DOUBLE, n_dim, lonid)
-      iret = NF90_DEF_VAR(trajid, 'lat', NF90_DOUBLE, n_dim, latid)
-      iret = NF90_DEF_VAR(trajid, 'xi', NF90_DOUBLE, n_dim, xid)
-      iret = NF90_DEF_VAR(trajid, 'yj', NF90_DOUBLE, n_dim, yid)
-      iret = NF90_DEF_VAR(trajid, 'uvel', NF90_DOUBLE, n_dim, uvelid)
-      iret = NF90_DEF_VAR(trajid, 'vvel', NF90_DOUBLE, n_dim, vvelid)
-      iret = NF90_DEF_VAR(trajid, 'uto', NF90_DOUBLE, n_dim, uoid)
-      iret = NF90_DEF_VAR(trajid, 'vto', NF90_DOUBLE, n_dim, void)
-      iret = NF90_DEF_VAR(trajid, 'uta', NF90_DOUBLE, n_dim, uaid)
-      iret = NF90_DEF_VAR(trajid, 'vta', NF90_DOUBLE, n_dim, vaid)
-      iret = NF90_DEF_VAR(trajid, 'uti', NF90_DOUBLE, n_dim, uiid)
-      iret = NF90_DEF_VAR(trajid, 'vti', NF90_DOUBLE, n_dim, viid)
-      iret = NF90_DEF_VAR(trajid, 'ssh_x', NF90_DOUBLE, n_dim, sshyid)
-      iret = NF90_DEF_VAR(trajid, 'ssh_y', NF90_DOUBLE, n_dim, sshxid)
-      iret = NF90_DEF_VAR(trajid, 'sst', NF90_DOUBLE, n_dim, sstid)
-      iret = NF90_DEF_VAR(trajid, 'icnt', NF90_DOUBLE, n_dim, cntid)
-      iret = NF90_DEF_VAR(trajid, 'ithk', NF90_DOUBLE, n_dim, thkid)
-      iret = NF90_DEF_VAR(trajid, 'mass', NF90_DOUBLE, n_dim, massid)
-      iret = NF90_DEF_VAR(trajid, 'thickness', NF90_DOUBLE, n_dim, thicknessid)
-      iret = NF90_DEF_VAR(trajid, 'width', NF90_DOUBLE, n_dim, widthid)
-      iret = NF90_DEF_VAR(trajid, 'length', NF90_DOUBLE, n_dim, lengthid)
-      iret = NF90_DEF_VAR(trajid, 'year', NF90_INT, n_dim, yearid)
-      iret = NF90_DEF_VAR(trajid, 'day', NF90_DOUBLE, n_dim, dayid)
-      iret = NF90_DEF_VAR(trajid, 'mass_of_bits', NF90_DOUBLE, n_dim, mass_of_bits_id)
-      iret = NF90_DEF_VAR(trajid, 'heat_density', NF90_DOUBLE, n_dim, heat_density_id)
+      iret = NF90_DEF_VAR(ntrajid, 'iceberg_number', NF90_INT, (/m_dim,n_dim/), numberid)
+      iret = NF90_DEF_VAR(ntrajid, 'timestep', NF90_INT, n_dim, nstepid)
+      iret = NF90_DEF_VAR(ntrajid, 'mass_scaling', NF90_DOUBLE, n_dim, nscaling_id)
+      iret = NF90_DEF_VAR(ntrajid, 'lon', NF90_DOUBLE, n_dim, nlonid)
+      iret = NF90_DEF_VAR(ntrajid, 'lat', NF90_DOUBLE, n_dim, nlatid)
+      iret = NF90_DEF_VAR(ntrajid, 'xi', NF90_DOUBLE, n_dim, nxid)
+      iret = NF90_DEF_VAR(ntrajid, 'yj', NF90_DOUBLE, n_dim, nyid)
+      iret = NF90_DEF_VAR(ntrajid, 'uvel', NF90_DOUBLE, n_dim, nuvelid)
+      iret = NF90_DEF_VAR(ntrajid, 'vvel', NF90_DOUBLE, n_dim, nvvelid)
+      iret = NF90_DEF_VAR(ntrajid, 'uto', NF90_DOUBLE, n_dim, nuoid)
+      iret = NF90_DEF_VAR(ntrajid, 'vto', NF90_DOUBLE, n_dim, nvoid)
+      iret = NF90_DEF_VAR(ntrajid, 'uta', NF90_DOUBLE, n_dim, nuaid)
+      iret = NF90_DEF_VAR(ntrajid, 'vta', NF90_DOUBLE, n_dim, nvaid)
+      iret = NF90_DEF_VAR(ntrajid, 'uti', NF90_DOUBLE, n_dim, nuiid)
+      iret = NF90_DEF_VAR(ntrajid, 'vti', NF90_DOUBLE, n_dim, nviid)
+      iret = NF90_DEF_VAR(ntrajid, 'ssh_x', NF90_DOUBLE, n_dim, nsshyid)
+      iret = NF90_DEF_VAR(ntrajid, 'ssh_y', NF90_DOUBLE, n_dim, nsshxid)
+      iret = NF90_DEF_VAR(ntrajid, 'sst', NF90_DOUBLE, n_dim, nsstid)
+      iret = NF90_DEF_VAR(ntrajid, 'icnt', NF90_DOUBLE, n_dim, ncntid)
+      iret = NF90_DEF_VAR(ntrajid, 'ithk', NF90_DOUBLE, n_dim, nthkid)
+      iret = NF90_DEF_VAR(ntrajid, 'mass', NF90_DOUBLE, n_dim, nmassid)
+      iret = NF90_DEF_VAR(ntrajid, 'thickness', NF90_DOUBLE, n_dim, nthicknessid)
+      iret = NF90_DEF_VAR(ntrajid, 'width', NF90_DOUBLE, n_dim, nwidthid)
+      iret = NF90_DEF_VAR(ntrajid, 'length', NF90_DOUBLE, n_dim, nlengthid)
+      iret = NF90_DEF_VAR(ntrajid, 'year', NF90_INT, n_dim, nyearid)
+      iret = NF90_DEF_VAR(ntrajid, 'day', NF90_DOUBLE, n_dim, ndayid)
+      iret = NF90_DEF_VAR(ntrajid, 'mass_of_bits', NF90_DOUBLE, n_dim, nmass_of_bits_id)
+      iret = NF90_DEF_VAR(ntrajid, 'heat_density', NF90_DOUBLE, n_dim, nheat_density_id)
 
       ! Attributes
-      iret = NF90_PUT_ATT(trajid, numberid, 'long_name', 'iceberg number on this processor')
-      iret = NF90_PUT_ATT(trajid, numberid, 'units', 'count')
-      iret = NF90_PUT_ATT(trajid, stepid, 'long_name', 'timestep number kt')
-      iret = NF90_PUT_ATT(trajid, stepid, 'units', 'count')
-      iret = NF90_PUT_ATT(trajid, lonid, 'long_name', 'longitude')
-      iret = NF90_PUT_ATT(trajid, lonid, 'units', 'degrees_E')
-      iret = NF90_PUT_ATT(trajid, latid, 'long_name', 'latitude')
-      iret = NF90_PUT_ATT(trajid, latid, 'units', 'degrees_N')
-      iret = NF90_PUT_ATT(trajid, xid, 'long_name', 'x grid box position')
-      iret = NF90_PUT_ATT(trajid, xid, 'units', 'fractional')
-      iret = NF90_PUT_ATT(trajid, yid, 'long_name', 'y grid box position')
-      iret = NF90_PUT_ATT(trajid, yid, 'units', 'fractional')
-      iret = NF90_PUT_ATT(trajid, uvelid, 'long_name', 'zonal velocity')
-      iret = NF90_PUT_ATT(trajid, uvelid, 'units', 'm/s')
-      iret = NF90_PUT_ATT(trajid, vvelid, 'long_name', 'meridional velocity')
-      iret = NF90_PUT_ATT(trajid, vvelid, 'units', 'm/s')
-      iret = NF90_PUT_ATT(trajid, uoid, 'long_name', 'ocean u component')
-      iret = NF90_PUT_ATT(trajid, uoid, 'units', 'm/s')
-      iret = NF90_PUT_ATT(trajid, void, 'long_name', 'ocean v component')
-      iret = NF90_PUT_ATT(trajid, void, 'units', 'm/s')
-      iret = NF90_PUT_ATT(trajid, uaid, 'long_name', 'atmosphere u component')
-      iret = NF90_PUT_ATT(trajid, uaid, 'units', 'm/s')
-      iret = NF90_PUT_ATT(trajid, vaid, 'long_name', 'atmosphere v component')
-      iret = NF90_PUT_ATT(trajid, vaid, 'units', 'm/s')
-      iret = NF90_PUT_ATT(trajid, uiid, 'long_name', 'sea ice u component')
-      iret = NF90_PUT_ATT(trajid, uiid, 'units', 'm/s')
-      iret = NF90_PUT_ATT(trajid, viid, 'long_name', 'sea ice v component')
-      iret = NF90_PUT_ATT(trajid, viid, 'units', 'm/s')
-      iret = NF90_PUT_ATT(trajid, sshxid, 'long_name', 'sea surface height gradient from x points')
-      iret = NF90_PUT_ATT(trajid, sshxid, 'units', 'm/m')
-      iret = NF90_PUT_ATT(trajid, sshyid, 'long_name', 'sea surface height gradient from y points')
-      iret = NF90_PUT_ATT(trajid, sshyid, 'units', 'm/m')
-      iret = NF90_PUT_ATT(trajid, sstid, 'long_name', 'sea surface temperature')
-      iret = NF90_PUT_ATT(trajid, sstid, 'units', 'degC')
-      iret = NF90_PUT_ATT(trajid, cntid, 'long_name', 'sea ice concentration')
-      iret = NF90_PUT_ATT(trajid, cntid, 'units', 'degC')
-      iret = NF90_PUT_ATT(trajid, thkid, 'long_name', 'sea ice thickness')
-      iret = NF90_PUT_ATT(trajid, thkid, 'units', 'm')
-      iret = NF90_PUT_ATT(trajid, massid, 'long_name', 'mass')
-      iret = NF90_PUT_ATT(trajid, massid, 'units', 'kg')
-      iret = NF90_PUT_ATT(trajid, thicknessid, 'long_name', 'thickness')
-      iret = NF90_PUT_ATT(trajid, thicknessid, 'units', 'm')
-      iret = NF90_PUT_ATT(trajid, widthid, 'long_name', 'width')
-      iret = NF90_PUT_ATT(trajid, widthid, 'units', 'm')
-      iret = NF90_PUT_ATT(trajid, lengthid, 'long_name', 'length')
-      iret = NF90_PUT_ATT(trajid, lengthid, 'units', 'm')
-      iret = NF90_PUT_ATT(trajid, yearid, 'long_name', 'calendar year')
-      iret = NF90_PUT_ATT(trajid, yearid, 'units', 'years')
-      iret = NF90_PUT_ATT(trajid, dayid, 'long_name', 'day of year')
-      iret = NF90_PUT_ATT(trajid, dayid, 'units', 'days')
-      iret = NF90_PUT_ATT(trajid, scaling_id, 'long_name', 'scaling factor for mass of berg')
-      iret = NF90_PUT_ATT(trajid, scaling_id, 'units', 'none')
-      iret = NF90_PUT_ATT(trajid, mass_of_bits_id, 'long_name', 'mass of bergy bits')
-      iret = NF90_PUT_ATT(trajid, mass_of_bits_id, 'units', 'kg')
-      iret = NF90_PUT_ATT(trajid, heat_density_id, 'long_name', 'heat density')
-      iret = NF90_PUT_ATT(trajid, heat_density_id, 'units', 'J/kg')
+      iret = NF90_PUT_ATT(ntrajid, numberid, 'long_name', 'iceberg number on this processor')
+      iret = NF90_PUT_ATT(ntrajid, numberid, 'units', 'count')
+      iret = NF90_PUT_ATT(ntrajid, nstepid, 'long_name', 'timestep number kt')
+      iret = NF90_PUT_ATT(ntrajid, nstepid, 'units', 'count')
+      iret = NF90_PUT_ATT(ntrajid, nlonid, 'long_name', 'longitude')
+      iret = NF90_PUT_ATT(ntrajid, nlonid, 'units', 'degrees_E')
+      iret = NF90_PUT_ATT(ntrajid, nlatid, 'long_name', 'latitude')
+      iret = NF90_PUT_ATT(ntrajid, nlatid, 'units', 'degrees_N')
+      iret = NF90_PUT_ATT(ntrajid, nxid, 'long_name', 'x grid box position')
+      iret = NF90_PUT_ATT(ntrajid, nxid, 'units', 'fractional')
+      iret = NF90_PUT_ATT(ntrajid, nyid, 'long_name', 'y grid box position')
+      iret = NF90_PUT_ATT(ntrajid, nyid, 'units', 'fractional')
+      iret = NF90_PUT_ATT(ntrajid, nuvelid, 'long_name', 'zonal velocity')
+      iret = NF90_PUT_ATT(ntrajid, nuvelid, 'units', 'm/s')
+      iret = NF90_PUT_ATT(ntrajid, nvvelid, 'long_name', 'meridional velocity')
+      iret = NF90_PUT_ATT(ntrajid, nvvelid, 'units', 'm/s')
+      iret = NF90_PUT_ATT(ntrajid, nuoid, 'long_name', 'ocean u component')
+      iret = NF90_PUT_ATT(ntrajid, nuoid, 'units', 'm/s')
+      iret = NF90_PUT_ATT(ntrajid, nvoid, 'long_name', 'ocean v component')
+      iret = NF90_PUT_ATT(ntrajid, nvoid, 'units', 'm/s')
+      iret = NF90_PUT_ATT(ntrajid, nuaid, 'long_name', 'atmosphere u component')
+      iret = NF90_PUT_ATT(ntrajid, nuaid, 'units', 'm/s')
+      iret = NF90_PUT_ATT(ntrajid, nvaid, 'long_name', 'atmosphere v component')
+      iret = NF90_PUT_ATT(ntrajid, nvaid, 'units', 'm/s')
+      iret = NF90_PUT_ATT(ntrajid, nuiid, 'long_name', 'sea ice u component')
+      iret = NF90_PUT_ATT(ntrajid, nuiid, 'units', 'm/s')
+      iret = NF90_PUT_ATT(ntrajid, nviid, 'long_name', 'sea ice v component')
+      iret = NF90_PUT_ATT(ntrajid, nviid, 'units', 'm/s')
+      iret = NF90_PUT_ATT(ntrajid, nsshxid, 'long_name', 'sea surface height gradient from x points')
+      iret = NF90_PUT_ATT(ntrajid, nsshxid, 'units', 'm/m')
+      iret = NF90_PUT_ATT(ntrajid, nsshyid, 'long_name', 'sea surface height gradient from y points')
+      iret = NF90_PUT_ATT(ntrajid, nsshyid, 'units', 'm/m')
+      iret = NF90_PUT_ATT(ntrajid, nsstid, 'long_name', 'sea surface temperature')
+      iret = NF90_PUT_ATT(ntrajid, nsstid, 'units', 'degC')
+      iret = NF90_PUT_ATT(ntrajid, ncntid, 'long_name', 'sea ice concentration')
+      iret = NF90_PUT_ATT(ntrajid, ncntid, 'units', 'degC')
+      iret = NF90_PUT_ATT(ntrajid, nthkid, 'long_name', 'sea ice thickness')
+      iret = NF90_PUT_ATT(ntrajid, nthkid, 'units', 'm')
+      iret = NF90_PUT_ATT(ntrajid, nmassid, 'long_name', 'mass')
+      iret = NF90_PUT_ATT(ntrajid, nmassid, 'units', 'kg')
+      iret = NF90_PUT_ATT(ntrajid, nthicknessid, 'long_name', 'thickness')
+      iret = NF90_PUT_ATT(ntrajid, nthicknessid, 'units', 'm')
+      iret = NF90_PUT_ATT(ntrajid, nwidthid, 'long_name', 'width')
+      iret = NF90_PUT_ATT(ntrajid, nwidthid, 'units', 'm')
+      iret = NF90_PUT_ATT(ntrajid, nlengthid, 'long_name', 'length')
+      iret = NF90_PUT_ATT(ntrajid, nlengthid, 'units', 'm')
+      iret = NF90_PUT_ATT(ntrajid, nyearid, 'long_name', 'calendar year')
+      iret = NF90_PUT_ATT(ntrajid, nyearid, 'units', 'years')
+      iret = NF90_PUT_ATT(ntrajid, ndayid, 'long_name', 'day of year')
+      iret = NF90_PUT_ATT(ntrajid, ndayid, 'units', 'days')
+      iret = NF90_PUT_ATT(ntrajid, nscaling_id, 'long_name', 'scaling factor for mass of berg')
+      iret = NF90_PUT_ATT(ntrajid, nscaling_id, 'units', 'none')
+      iret = NF90_PUT_ATT(ntrajid, nmass_of_bits_id, 'long_name', 'mass of bergy bits')
+      iret = NF90_PUT_ATT(ntrajid, nmass_of_bits_id, 'units', 'kg')
+      iret = NF90_PUT_ATT(ntrajid, nheat_density_id, 'long_name', 'heat density')
+      iret = NF90_PUT_ATT(ntrajid, nheat_density_id, 'units', 'J/kg')
 
       ! End define mode
-      iret = NF90_ENDDEF(trajid)
+      iret = NF90_ENDDEF(ntrajid)
 
    END SUBROUTINE traj_init
@@ -173,6 +173,6 @@
       INTEGER, INTENT( in )                 :: kt
       ! Local variables
-      INTEGER                               :: iret, k
-      CHARACTER(len=80)                     :: filename
+      INTEGER                               :: iret, jn
+      CHARACTER(len=80)                     :: cl_filename
       TYPE(iceberg), POINTER                :: this
       TYPE(point)  , POINTER                :: pt
@@ -182,43 +182,43 @@
 
       this => first_berg
-      k = kount_traj
+      jn = num_traj
       DO WHILE (ASSOCIATED(this))
          pt => this%current_point
-         k=k+1
-
-         iret = NF90_PUT_VAR(trajid, numberid, this%number, (/1,k/), (/nkounts,1/) )
-         iret = NF90_PUT_VAR(trajid, stepid, kt, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, scaling_id, this%mass_scaling, (/ k /) )
-
-         iret = NF90_PUT_VAR(trajid, lonid, pt%lon, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, latid, pt%lat, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, xid, pt%xi, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, yid, pt%yj, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, uvelid, pt%uvel, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, vvelid, pt%vvel, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, uoid, pt%uo, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, void, pt%vo, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, uaid, pt%ua, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, vaid, pt%va, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, uiid, pt%ui, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, viid, pt%vi, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, sshxid, pt%ssh_x, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, sshyid, pt%ssh_y, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, sstid, pt%sst, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, cntid, pt%cn, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, thkid, pt%hi, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, massid, pt%mass, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, thicknessid, pt%thickness, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, widthid, pt%width, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, lengthid, pt%length, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, yearid, pt%year, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, dayid, pt%day, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, mass_of_bits_id, pt%mass_of_bits, (/ k /) )
-         iret = NF90_PUT_VAR(trajid, heat_density_id, pt%heat_density, (/ k /) )
+         jn=jn+1
+
+         iret = NF90_PUT_VAR(ntrajid, numberid, this%number, (/1,jn/), (/nkounts,1/) )
+         iret = NF90_PUT_VAR(ntrajid, nstepid, kt, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nscaling_id, this%mass_scaling, (/ jn /) )
+
+         iret = NF90_PUT_VAR(ntrajid, nlonid, pt%lon, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nlatid, pt%lat, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nxid, pt%xi, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nyid, pt%yj, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nuvelid, pt%uvel, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nvvelid, pt%vvel, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nuoid, pt%uo, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nvoid, pt%vo, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nuaid, pt%ua, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nvaid, pt%va, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nuiid, pt%ui, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nviid, pt%vi, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nsshxid, pt%ssh_x, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nsshyid, pt%ssh_y, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nsstid, pt%sst, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, ncntid, pt%cn, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nthkid, pt%hi, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nmassid, pt%mass, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nthicknessid, pt%thickness, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nwidthid, pt%width, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nlengthid, pt%length, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nyearid, pt%year, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, ndayid, pt%day, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nmass_of_bits_id, pt%mass_of_bits, (/ jn /) )
+         iret = NF90_PUT_VAR(ntrajid, nheat_density_id, pt%heat_density, (/ jn /) )
 
          this=>this%next
       ENDDO
-      IF( lwp .and. nn_verbose_level > 0 ) WRITE(numout,*) 'trajectory write to frame ', k
-      kount_traj = k
+      IF( lwp .and. nn_verbose_level > 0 ) WRITE(numout,*) 'trajectory write to frame ', jn
+      num_traj = jn
 
    END SUBROUTINE traj_write
@@ -231,5 +231,5 @@
 
       ! flush to file
-      iret = NF90_SYNC(trajid)
+      iret = NF90_SYNC(ntrajid)
       IF (iret .NE. NF90_NOERR) CALL ctl_stop('icebergs, traj_sync: nf_sync failed')
 
@@ -243,5 +243,5 @@
 
       ! Finish up
-      iret = NF90_CLOSE(trajid)
+      iret = NF90_CLOSE(ntrajid)
       IF (iret .NE. NF90_NOERR) CALL ctl_stop('icebergs, traj_end: nf_close failed')
 
Index: /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbutl.F90
===================================================================
--- /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbutl.F90	(revision 3358)
+++ /branches/2012/dev_r3337_NOCS10_ICB/NEMOGCM/NEMO/OPA_SRC/ICB/icbutl.F90	(revision 3359)
@@ -34,21 +34,21 @@
    PRIVATE
 
-   PUBLIC   copy_flds                ! routine called in xxx.F90 module
-   PUBLIC   interp_flds              ! routine called in xxx.F90 module
-   PUBLIC   bilin
-   PUBLIC   bilin_x
-   PUBLIC   bilin_e
-   PUBLIC   add_new_berg_to_list
-   PUBLIC   insert_berg_into_list
-   PUBLIC   delete_iceberg_from_list
-   PUBLIC   destroy_iceberg
-   PUBLIC   track_berg
-   PUBLIC   print_berg
-   PUBLIC   print_bergs
-   PUBLIC   count_bergs
-   PUBLIC   increment_kounter
-   PUBLIC   yearday
-   PUBLIC   sum_mass
-   PUBLIC   sum_heat
+   PUBLIC   copy_flds                    ! routine called in icbrun module
+   PUBLIC   interp_flds                  ! routine called in icbdyn, icbthm modules
+   PUBLIC   bilin                        ! routine called in icbini, icbdyn modules
+   PUBLIC   bilin_x                      ! routine called in icbdyn module
+   PRIVATE  bilin_e
+   PUBLIC   add_new_berg_to_list         ! routine called in icbini.F90, icbclv, icblbc and icbrst modules
+   PRIVATE  insert_berg_into_list
+   PUBLIC   delete_iceberg_from_list     ! routine called in icblbc, icbthm modules
+   PUBLIC   destroy_iceberg              ! routine called in icbrun module
+   PUBLIC   track_berg                   ! routine not currently used, retain just in case
+   PUBLIC   print_berg                   ! routine called in icbthm module
+   PUBLIC   print_bergs                  ! routine called in icbini, icbrun module
+   PUBLIC   count_bergs                  ! routine called in icbdia, icbini, icblbc, icbrst modules
+   PUBLIC   increment_kounter            ! routine called in icbini, icbclv modules
+   PUBLIC   yearday                      ! routine called in icbclv, icbrun module
+   PUBLIC   sum_mass                     ! routine called in icbdia module
+   PUBLIC   sum_heat                     ! routine called in icbdia module
 
    PRIVATE  create_iceberg
@@ -109,6 +109,7 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE interp_flds( pi, pe1, puo, pui, pua, pssh_i,                     &
-      &                    pj, pe2, pvo, pvi, pva, pssh_j, psst, pcn, phi, pff )
+   SUBROUTINE interp_flds( pi, pe1, puo, pui, pua, pssh_i,   &
+      &                    pj, pe2, pvo, pvi, pva, pssh_j,   &
+      &                    psst, pcn, phi, pff )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE interp_flds  ***
@@ -168,5 +169,5 @@
    !!-------------------------------------------------------------------------
 
-   REAL(wp) FUNCTION bilin( pfld, pi, pj, cd_type, jdi, jdj )
+   REAL(wp) FUNCTION bilin( pfld, pi, pj, cd_type, kdi, kdj )
       !!----------------------------------------------------------------------
       !!                  ***  FUNCTION bilin  ***
@@ -178,6 +179,6 @@
       !!
       !!----------------------------------------------------------------------
-      INTEGER                                         , INTENT(in) ::   jdi, jdj  ! extra halo on grid
-      REAL(wp), DIMENSION(1-jdi:jpi+jdi,1-jdj:jpj+jdj), INTENT(in) ::   pfld      ! field to be interpolated
+      INTEGER                                         , INTENT(in) ::   kdi, kdj  ! extra halo on grid
+      REAL(wp), DIMENSION(1-kdi:jpi+kdi,1-kdj:jpj+kdj), INTENT(in) ::   pfld      ! field to be interpolated
       REAL(wp)                                        , INTENT(in) ::   pi, pj    ! targeted coordinates in (i,j) referential
       CHARACTER(len=1)                                , INTENT(in) ::   cd_type   ! type of pfld array grid-points: = T , U , V or F points
@@ -424,14 +425,13 @@
    !!-------------------------------------------------------------------------
 
-   REAL(wp) FUNCTION yearday(imon, iday, ihr, imin, isec)
+   REAL(wp) FUNCTION yearday(kmon, kday, khr, kmin, ksec)
       ! sga - improved but still only applies to 365 day year, need to do this properly
       ! Arguments
-      INTEGER, intent(in)     :: imon, iday, ihr, imin, isec
+      INTEGER, intent(in)     :: kmon, kday, khr, kmin, ksec
       ! Local variables
-      INTEGER                 :: i
-      INTEGER, DIMENSION(12)  :: months = (/ 0,31,28,31,30,31,30,31,31,30,31,30 /)
-
-      yearday = FLOAT( SUM( months(1:imon) ) )
-      yearday = yearday + FLOAT(iday-1) + (FLOAT(ihr) + (FLOAT(imin) + FLOAT(isec)/60.)/60.)/24.
+      INTEGER, DIMENSION(12)  :: imonths = (/ 0,31,28,31,30,31,30,31,31,30,31,30 /)
+
+      yearday = FLOAT( SUM( imonths(1:kmon) ) )
+      yearday = yearday + FLOAT(kday-1) + (FLOAT(khr) + (FLOAT(kmin) + FLOAT(ksec)/60.)/60.)/24.
 
    END FUNCTION yearday
@@ -458,5 +458,5 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE destroy_iceberg(berg)
+   SUBROUTINE destroy_iceberg( berg )
       ! Arguments
       TYPE(iceberg), POINTER :: berg
@@ -472,8 +472,8 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE track_berg( num, label, kt )
+   SUBROUTINE track_berg( knum, cd_label, kt )
       ! Arguments
-      INTEGER, DIMENSION(nkounts)    :: num            ! iceberg number
-      CHARACTER(len=*)               :: label
+      INTEGER, DIMENSION(nkounts)    :: knum            ! iceberg number
+      CHARACTER(len=*)               :: cd_label
       INTEGER                        :: kt             ! timestep number
       ! Local variables
@@ -486,5 +486,5 @@
          match = .TRUE.
          DO k=1,nkounts
-            IF( this%number(k) /= num(k) ) match = .FALSE.
+            IF( this%number(k) /= knum(k) ) match = .FALSE.
          END DO
          IF( match ) CALL print_berg(this, kt)
@@ -513,15 +513,15 @@
    !!-------------------------------------------------------------------------
 
-   SUBROUTINE print_bergs( label, kt )
+   SUBROUTINE print_bergs( cd_label, kt )
       ! Arguments
-      CHARACTER(len=*)       :: label
+      CHARACTER(len=*)       :: cd_label
       INTEGER                :: kt             ! timestep number
       ! Local variables
-      INTEGER                :: nbergs, nnbergs
+      INTEGER                :: ibergs, inbergs
       TYPE(iceberg), POINTER :: this
 
       this => first_berg
       IF( ASSOCIATED(this) ) THEN
-         WRITE(numicb,'(a," pe=(",i3,")")' ) label, narea
+         WRITE(numicb,'(a," pe=(",i3,")")' ) cd_label, narea
          WRITE(numicb,'(a8,4x,a6,12x,a5,15x,a7,19x,a3,17x,a5,17x,a5,17x,a5)' )   &
                       'timestep', 'number', 'xi,yj','lon,lat','u,v','uo,vo','ua,va','ui,vi'
@@ -531,9 +531,9 @@
         this => this%next
       ENDDO
-      nbergs = count_bergs()
-      nnbergs = nbergs
-      IF( lk_mpp ) CALL mpp_sum(nnbergs)
-      IF ( nbergs .GT. 0 ) WRITE(numicb,'(a," there are",i5," bergs out of",i6," on PE ",i4)') &
-                                           label, nbergs, nnbergs, narea
+      ibergs = count_bergs()
+      inbergs = ibergs
+      IF( lk_mpp ) CALL mpp_sum(inbergs)
+      IF ( ibergs .GT. 0 ) WRITE(numicb,'(a," there are",i5," bergs out of",i6," on PE ",i4)') &
+                                           cd_label, ibergs, inbergs, narea
 
    END SUBROUTINE print_bergs
@@ -543,5 +543,5 @@
    SUBROUTINE increment_kounter()
       ! Small routine for coping with very large integer values labelling icebergs
-      ! kount_bergs is a array of integers
+      ! num_bergs is a array of integers
       ! the first member is incremented in steps of jpnij starting from narea
       ! this means each iceberg is labelled with a unique number
@@ -550,20 +550,20 @@
 
       ! Local variables
-      INTEGER                :: i, ibig
-
-      ibig = HUGE(kount_bergs(1))
-      IF( ibig-jpnij < kount_bergs(1) ) THEN
-         kount_bergs(1) = narea
-         DO i = 2,nkounts
-            IF( kount_bergs(i) == ibig ) THEN
-               kount_bergs(i) = 0
-               IF( i == nkounts ) CALL ctl_stop('Sorry, run out of iceberg number space')
+      INTEGER                :: ii, ibig
+
+      ibig = HUGE(num_bergs(1))
+      IF( ibig-jpnij < num_bergs(1) ) THEN
+         num_bergs(1) = narea
+         DO ii = 2,nkounts
+            IF( num_bergs(ii) == ibig ) THEN
+               num_bergs(ii) = 0
+               IF( ii == nkounts ) CALL ctl_stop('Sorry, run out of iceberg number space')
             ELSE
-               kount_bergs(i) = kount_bergs(i) + 1
+               num_bergs(ii) = num_bergs(ii) + 1
                EXIT
             ENDIF
          END DO
       ELSE
-         kount_bergs(1) = kount_bergs(1) + jpnij
+         num_bergs(1) = num_bergs(1) + jpnij
       ENDIF
 
